package com.example.combustible;

import java.util.Vector;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class AdaptadorListView extends BaseAdapter {
	private final Activity actividad;
	private final Vector<Ciudad> ciudades;

	public AdaptadorListView(Activity actividad, Vector<Ciudad> ciudades) {
		super();
		this.actividad = actividad;
		this.ciudades = ciudades;
	}

	public View getView(int position, View convertView, ViewGroup parent) {
		LayoutInflater inflater = actividad.getLayoutInflater();
		View view;
		if (ciudades.elementAt(position).nombre.equals("")) {
			view = inflater.inflate(R.layout.elemento_lista_provincia, null,
					true);
			TextView textProvincia = (TextView) view
					.findViewById(R.id.textProvincia);
			textProvincia
					.setText(ciudades.elementAt(position).provincia.nombre);
			textProvincia.setTextAppearance(actividad,
					android.R.style.TextAppearance_Large);
			if (position % 2 == 1) {
				textProvincia.setBackgroundColor(actividad.getResources()
						.getColor(R.color.blanco_listView));
			} else {
				textProvincia.setBackgroundColor(actividad.getResources()
						.getColor(R.color.gris_listView));
			}

		} else {
			view = inflater.inflate(R.layout.elemento_lista, null, true);
			TextView textCiudad = (TextView) view.findViewById(R.id.textCiudad);
			textCiudad.setText(ciudades.elementAt(position).nombre);
			TextView textProvincia = (TextView) view
					.findViewById(R.id.textProvincia);
			textProvincia
					.setText(ciudades.elementAt(position).provincia.nombre);
			if (position % 2 == 1) {
				textCiudad.setBackgroundColor(actividad.getResources()
						.getColor(R.color.blanco_listView));
				textProvincia.setBackgroundColor(actividad.getResources()
						.getColor(R.color.blanco_listView));
			} else {
				textCiudad.setBackgroundColor(actividad.getResources()
						.getColor(R.color.gris_listView));
				textProvincia.setBackgroundColor(actividad.getResources()
						.getColor(R.color.gris_listView));
			}
		}

		return view;
	}

	public int getCount() {
		return ciudades.size();
	}

	public Object getItem(int arg0) {
		return ciudades.elementAt(arg0);
	}

	public long getItemId(int position) {
		return position;
	}
}
