package com.example.combustible;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;

import android.content.Context;
import android.util.Log;

public class AlmacenFicheroInterno {
	private static String FICHERO = "ciudad.txt";
	private Context context;

	public AlmacenFicheroInterno(Context context) {
		this.context = context;
	}

	public void guardarCiudad(Ciudad ciudad) {
		try {
			FileOutputStream f = context.openFileOutput(FICHERO,
					Context.MODE_PRIVATE);
			String texto = ciudad.nombre + ";" + ciudad.codProv + ";"
					+ ciudad.provincia.nombre + "\n";
			f.write(texto.getBytes());
			f.close();
		} catch (Exception e) {
			Log.e("Combustible", e.getMessage(), e);
		}
	}

	public Ciudad devolverCiudad(Ciudad ciudad) {

		try {
			FileInputStream f = context.openFileInput(FICHERO);
			BufferedReader entrada = new BufferedReader(
					new InputStreamReader(f));
			String lineaCiudad = entrada.readLine();

			if (lineaCiudad != null) {
				String[] partesCiudad = lineaCiudad.split(";");
				ciudad.nombre = partesCiudad[0];
				ciudad.codProv = Integer.valueOf(partesCiudad[1]);
				ciudad.provincia.nombre = partesCiudad[2];
			}
			f.close();
		} catch (Exception e) {
			Log.e("Ciudad", e.getMessage(), e);
		}
		return ciudad;
	}
}
