package com.example.combustible;

import java.util.Vector;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.EditText;
import android.widget.ListView;

public class BuscarActivity extends ListActivity {

	private RecuperarDatosSQL recuperarDatosSQL;
	private EditText ciudBuscar;
	private AdaptadorListView ciudAdapterListView;
	private Vector<Ciudad> itemLugares;
	public Ciudad provSeleccionada;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.buscar_ciudad);
		itemLugares = new Vector<Ciudad>();
		provSeleccionada = new Ciudad(0);
		try {
			recuperarDatosSQL = new RecuperarDatosSQL(this);
			mostrarProvincias();
			ciudBuscar = (EditText) findViewById(R.id.ciudBuscar);
			ciudBuscar.addTextChangedListener(new TextWatcher() {
				@Override
				public void onTextChanged(CharSequence arg0, int arg1,
						int arg2, int arg3) {
					String texto = ciudBuscar.getText().toString();
					itemLugares = recuperarDatosSQL.buscarCiudades(texto,
							provSeleccionada.provincia);
					if (texto.equals("")) {
						provSeleccionada = new Ciudad(0);
						mostrarProvincias();
					} else {
						ciudAdapterListView = new AdaptadorListView(
								BuscarActivity.this, itemLugares);
					}
					setListAdapter(ciudAdapterListView);
				}

				@Override
				public void beforeTextChanged(CharSequence arg0, int arg1,
						int arg2, int arg3) {
				}

				@Override
				public void afterTextChanged(Editable arg0) {
				}
			});
			setListAdapter(ciudAdapterListView);

		} catch (NullPointerException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	protected void onListItemClick(ListView listView, View view, int position,
			long id) {
		super.onListItemClick(listView, view, position, id);
		Ciudad ciudad = (Ciudad) getListAdapter().getItem(position);
		provSeleccionada = ciudad;
		if (ciudad.nombre.equals("")) {
			itemLugares = recuperarDatosSQL
					.buscarCiudades("", ciudad.provincia);
			ciudAdapterListView = new AdaptadorListView(BuscarActivity.this,
					itemLugares);
			setListAdapter(ciudAdapterListView);

		} else {
			Intent intent = new Intent();
			intent.putExtra("ciudad", ciudad);
			setResult(RESULT_OK, intent);
			this.finish();
		}
	}

	public void mostrarProvincias() {
		itemLugares = recuperarDatosSQL.leerProvincias();
		ciudAdapterListView = new AdaptadorListView(BuscarActivity.this,
				itemLugares);
	}

	public void onBackPressed() {

		if (provSeleccionada.codProv == 0)
			finish();
		else {
			provSeleccionada = new Ciudad(0);
			mostrarProvincias();
			setListAdapter(ciudAdapterListView);
		}
	}

}
