package com.example.combustible;

import java.io.IOException;
import java.io.InputStream;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.TextView;

public class BuscarFragment extends Fragment {

	private transient static Context contexto;
	private static ViewPager pagerBuscar;
	private static Ciudad ciudad = new Ciudad(0);;
	private static String tipoGasolina;
	private TextView buscar;

	public static BuscarFragment newInstance(Context context, ViewPager pager) {

		BuscarFragment fragment = new BuscarFragment();
		contexto = context;
		pagerBuscar = pager;
		tipoGasolina = "4";

		return fragment;

	}

	@Override
	public void onCreate(Bundle estadoGuardado) {
		super.onActivityCreated(estadoGuardado);
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle estadoGuardado) {

		final ViewGroup rootView = (ViewGroup) inflater.inflate(
				R.layout.buscar, container, false);
		buscar = (TextView) rootView.findViewById(R.id.buscar);
		buscar.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {

				lanzarBuscarCiudad(null);

			}
		});

		RadioGroup radioGroup = (RadioGroup) rootView
				.findViewById(R.id.radioGroup);

		radioGroup.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			// OBTIENE EL TIPO DE GASOLINA CON EL TAG DEL RADIO PULSADO
			public void onCheckedChanged(RadioGroup group, int checkedId) {
				RadioButton rb = (RadioButton) rootView.findViewById(checkedId);
				tipoGasolina = rb.getTag().toString();
			}
		});
		Button buttonBuscar = (Button) rootView.findViewById(R.id.buttonBuscar);
		buttonBuscar.setOnClickListener(new OnClickListener() {
			// CUANDO PULSAMOS BUSCAR SI HAY CIUDAD SELECCIONADA LLAMA AL WEBSERVICE
			// EN CASO CONTRARIO APARECE ALERTBOX
			@Override
			public void onClick(View v) {
				if (ciudad.codProv != 0) {
					llamadaWebService();
				} else {

					new AlertDialog.Builder(contexto)
							.setTitle("Sin ciudad seleccionada")
							.setMessage(
									"Debes seleccionar una ciudad para poder hacer la bsqueda")
							.setPositiveButton(android.R.string.yes,
									new DialogInterface.OnClickListener() {
										public void onClick(
												DialogInterface dialog,
												int which) {

										}
									})
							.setIcon(android.R.drawable.ic_dialog_alert).show();
				}

			}

		});
		AlmacenFicheroInterno almacenFicheroInterno = new AlmacenFicheroInterno(
				contexto);
		ciudad = almacenFicheroInterno.devolverCiudad(ciudad);
		// SI NO HAY NINGUNA CIUDAD SELECCIONADA SE RECUPERA LA LTIMA QUE SE SELECCION
		if (ciudad.codProv!=0){
			buscar.setText(ciudad.nombre + " (" + ciudad.provincia.nombre + ")");
		}
		return rootView;
	}

	public void lanzarBuscarCiudad(View view) {

		// LLAMA AL ACTIVITY BUSCAR ESPERANDO RESPUESTA
		Intent i = new Intent(contexto, BuscarActivity.class);
		startActivityForResult(i, 4444);
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		// SI LA RESPUESTA ES POSITIVA MARCA LA CIUDAD COMO SELECCIONADA Y
		// LA PASA AL TEXTVIEW
		if (requestCode == 4444 && resultCode == android.app.Activity.RESULT_OK) {
			ciudad = (Ciudad) data.getExtras().getSerializable("ciudad");
			buscar.setText(ciudad.nombre + " (" + ciudad.provincia.nombre + ")");
		}
	}

	public void llamadaWebService() {
		Element resultados;
		String resultadosString = "";
		InputStream is = null;
		try {

			is = contexto.getAssets().open("estilos/html/plantilla.html");
			Document document = Jsoup.parse(is, "UTF-8", "http://example.com/");
			ServicioWeb_AsyncTask servicio = new ServicioWeb_AsyncTask(
					contexto, ciudad, tipoGasolina);
			resultados = servicio.codigoHtml();

			// AADIR ELEMENTO RESULTADOS
			document.select("body").first().append(resultados.toString());
			resultadosString = document.toString();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// PASO VALOR A FRAGMENT CON WEBVIEW
		ResultadosFragment resultadosFragment = new ResultadosFragment();
		Bundle args = new Bundle();
		args.putString("codigo", resultadosString);
		resultadosFragment.setArguments(args);
		getFragmentManager().beginTransaction()
				.add(R.id.webView, resultadosFragment).commit();
		// IR A VENTANA RESULTADOS
		pagerBuscar.setCurrentItem(2);
		// MARCAR GASOLINERAS EN FRAGMENT MAPA
		MapaFragment.marcarGasolineras();

	}

	@Override
	public void onPause() {
		// SI HAY ALGUNA CIUDAD SELECCIONADA SE GUARDA EN ALMACENAMIENTO INTERNO
		if (ciudad.codProv != 0) {
			AlmacenFicheroInterno almacenFicheroInterno = new AlmacenFicheroInterno(
					contexto);
			almacenFicheroInterno.guardarCiudad(ciudad);
		}
		super.onPause();
	}

}
