package com.example.combustible;

import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.view.ViewPager;

import com.viewpagerindicator.TitlePageIndicator;

public class MainActivity extends FragmentActivity {

	// EL VIEWPAGER PERMITE ANIMAR EL PASO DE FRAGMENTS 
	// DESPLAZANDONOS A LAS CONTIGUAS.
	ViewPager pager = null;
	// EL ADAPTAADOR NOS SERVIR PARA CARGAR LAS PAGINAS AL PAGEVIEWER
	MyFragmentPagerAdapter pagerAdapter;

	@Override
	protected void onCreate(Bundle arg0) {
		super.onCreate(arg0);
		this.setContentView(R.layout.activity_main);
		this.pager = (ViewPager) this.findViewById(R.id.pager);
		pager.setOffscreenPageLimit(3);
		// ASIGNA ANIMACIN PERSONALIZADA
		this.pager.setPageTransformer(true, new DepthPageTransformer());
		MyFragmentPagerAdapter adapter = new MyFragmentPagerAdapter(
				getSupportFragmentManager(),this);
		adapter.addFragment(AcercaDeFragment.newInstance());
		adapter.addFragment(BuscarFragment.newInstance(this, pager));
		adapter.addFragment(ResultadosFragment.newInstance(this));
		adapter.addFragment(MapaFragment.newInstance(this));
		this.pager.setAdapter(adapter);
		// TITLE INDICATOR PARA PAGEVIEWER NOS PERMITE INDICAR LOS TTULOS EN LAS PESTAAS
		TitlePageIndicator titleIndicator = (TitlePageIndicator) findViewById(R.id.indicator);
		titleIndicator.setViewPager(pager);
		pager.setCurrentItem(1);

	}

	@Override
	public void onBackPressed() {

		// PARA VOLVER A LA PESTAA ANTERIOR CON EL BOTN VOLVER
		if (this.pager.getCurrentItem() == 0)
			super.onBackPressed();
		else
			this.pager.setCurrentItem(this.pager.getCurrentItem() - 1);

	}

}
