package com.example.combustible;

import java.util.Vector;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentActivity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;

public class MapaFragment extends Fragment {

	private static FragmentActivity fragmentActivity;
	private static GoogleMap mapa;
	public static Vector<Gasolinera> gasolineras = new Vector<Gasolinera>();

	public static MapaFragment newInstance(FragmentActivity fragActivity) {

		MapaFragment fragment = new MapaFragment();
		fragmentActivity = fragActivity;
		
		return fragment;

	}
	
	public void onCreate(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);	
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		ViewGroup rootView = (ViewGroup) inflater.inflate(R.layout.mapa,
				container, false);
		mapa = ((SupportMapFragment) fragmentActivity
				.getSupportFragmentManager().findFragmentById(R.id.map))
				.getMap();
		mapa.setMapType(GoogleMap.MAP_TYPE_SATELLITE);
		mapa.setMyLocationEnabled(true);
		mapa.getUiSettings().setZoomControlsEnabled(true);
		mapa.getUiSettings().setCompassEnabled(true);
		
		if (gasolineras != null
				&& gasolineras.size() > 0)
			marcarGasolineras();

		return rootView;

	}

	public static void marcarGasolineras() {
		LatLng latLngMarcador;
		float xMax = 0, x = 0, xMin = 0, yMax = 0, y = 0, yMin = 0;
		int zoom = 0, numGasolineras = gasolineras.size();
		mapa.clear();
		for (Gasolinera gasolinera : gasolineras) {
			x = gasolinera.getX();
			y = gasolinera.getY();
			latLngMarcador = new LatLng(y, x);
			mapa.addMarker(new MarkerOptions()
					.position(latLngMarcador)
					.title(gasolinera.getNombre())
					.snippet(
							gasolinera.getUbicacion() + "\n"
									+ gasolinera.getCiudad())
					.icon(BitmapDescriptorFactory
							.fromResource(R.drawable.pushpin))
					.anchor(0.5f, 0.5f));
			// OBTENERMOS LOS VALORES MAYOR Y MENOR DE X E Y PARA CENTRAR LA CAMARA
			if (xMin == 0 && xMax == 0) {
				xMin = x;
				xMax = x;
			} else if (x > xMax) {
				xMax = x;
			} else if (x < xMin) {
				xMin = x;
			}
			if (yMin == 0 && yMax == 0) {
				yMin = y;
				yMax = y;
			} else if (y > yMax) {
				yMax = y;
			} else if (y < yMin) {
				yMin = y;
			}
			// MODIFICAMOS EL ZOOM DEPENDIENDO DE NMERO DE GASOLINERAS
			if (numGasolineras == 1) {
				zoom = 16;
			} else if (numGasolineras < 10) {
				zoom = 13;
			} else if (numGasolineras < 25) {
				zoom = 12;
			} else {
				zoom = 11;
			}
		}
		x = (xMax + xMin) / 2;
		y = (yMax + yMin) / 2;
		latLngMarcador = new LatLng(y, x);
		mapa.moveCamera(CameraUpdateFactory.newLatLngZoom(latLngMarcador, zoom));
	}


}
