package com.example.combustible;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.content.res.Resources;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;

public class MyFragmentPagerAdapter extends FragmentPagerAdapter {

	
	List<Fragment> fragments;
	Context contexto;

	public MyFragmentPagerAdapter(FragmentManager fm, Context context) {
		super(fm);
		this.fragments = new ArrayList<Fragment>();
		contexto = context;
	}

	public void addFragment(Fragment fragment) {
		this.fragments.add(fragment);
	}

	@Override
	public Fragment getItem(int arg0) {
		return this.fragments.get(arg0);
	}

	@Override
	public int getCount() {
		return this.fragments.size();
	}

	@Override
	public CharSequence getPageTitle(int position) {
		// AADIR TTULO A LAS PGINAS
		String nombrePagina;
		Resources res = contexto.getResources();
		String acercaDe = res.getString(R.string.acercaDe);
		String busqueda = res.getString(R.string.busqueda);
		String tabla = res.getString(R.string.tabla);
		String mapa = res.getString(R.string.mapa);

		if (position == 0) {
			nombrePagina = acercaDe;
		} else if (position == 1) {
			nombrePagina = busqueda;
		} else if (position == 2) {
			nombrePagina = tabla;
		} else {
			nombrePagina = mapa;
		}

		return nombrePagina;
	}

}
