package com.example.combustible;

import java.io.IOException;
import java.net.URLEncoder;
import java.util.concurrent.CancellationException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

public class ServicioWeb_AsyncTask {

	private Context contexto;
	private Ciudad ciudad;
	String tipoGasolina;

	public ServicioWeb_AsyncTask(Context contexto, Ciudad ciudad, String tipoGasolina) {

		this.contexto = contexto;
		this.ciudad = ciudad;
		this.tipoGasolina=tipoGasolina;
	}

	public Element codigoHtml() {
		try {
			Resultado resultado = new Resultado();
			// PASAMOS UN OBJETO CIUDAD AL ASYNC TASK PARA 
			// REALIZAR LA LLAMADA EN HILO INDEPENDIENTE
			resultado.execute(ciudad);
			return resultado.get(4, TimeUnit.SECONDS);
		} catch (TimeoutException e) {
			Toast.makeText(contexto, "Tiempo excedido al conectar",
					Toast.LENGTH_LONG).show();
		} catch (CancellationException e) {
			Toast.makeText(contexto, "Error al conectar con servidor",
					Toast.LENGTH_LONG).show();
		} catch (Exception e) {
			Toast.makeText(contexto, "Error con tarea asncrona",
					Toast.LENGTH_LONG).show();
		}
		Element sinResultados;
		Document documento = Jsoup.parse("Pagina de error");
		sinResultados = documento.select("body").first();
		return sinResultados;
	}

	private class Resultado extends AsyncTask<Ciudad, Void, Element> {
		@Override
		protected Element doInBackground(Ciudad... ciudad) {
			Element result = null;
			String url;
			Gasolinera gasolinera;
			MapaFragment.gasolineras.clear();
			try {
				url = "http://geoportalgasolineras.es/geoportalmovil/eess/search.do?tipoCarburante="
						+ tipoGasolina + "&rotulo=&economicas=on&venta=P&provincia="
						+ ciudad[0].codProv
						+ "&localidad="
						+ URLEncoder.encode(ciudad[0].nombre, "UTF-8")
						+ "&calle=" + "&numero=&codPostal=";
				Document doc;
				doc = Jsoup.connect(url).get();
				result = doc.select("div.content").first();

				Elements filas = result.select("tr");
				for (Element fila : filas) {
					if (fila != filas.get(0)) {
						gasolinera = new Gasolinera();
						Element enlace = fila.select("a[href]").first();
						int inicio=enlace.attr("href").indexOf("x=")+2;
						int fin=enlace.attr("href").indexOf("&y=");
						String x = enlace.attr("href").substring(inicio, fin);
						inicio=(enlace.attr("href").indexOf("y="))+2;
						fin=enlace.attr("href").length();
						String y = enlace.attr("href").substring(inicio, fin);
						String enlaceFinal = "http://maps.google.es/?q=" + y
								+ "%20" + x;
						enlace.attr("href", enlaceFinal);
						gasolinera.setX(Float.parseFloat(x));
						gasolinera.setY(Float.parseFloat(y));
						Elements celdas = fila.select("td");
						if (celdas.size() > 0) {
							gasolinera.setNombre(celdas.get(0).text());
							gasolinera.setCiudad(ciudad[0].nombre);
							gasolinera.setUbicacion(celdas.get(1).text());
						}
						MapaFragment.gasolineras.add(gasolinera);
					}
				}

			} catch (IOException e) {
				Log.e("Combustible", e.getMessage(), e);
				cancel(true);
			}

			return result;
		}
	}
}
